unit Main;

interface

uses
  OpenGL, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls;

type
  TfrmMain = class (TForm)
    Timer1 : TTimer;
    pOGL : TPanel;
    procedure FormCreate (Sender : TObject);
    procedure Timer1Timer (Sender : TObject);
    procedure FormKeyDown (Sender : TObject; var Key : Word; Shift : TShiftState);
  private
    procedure Draw;
    procedure DrawH (Width,Height,Thick,ColourR,ColourG,ColourB : GLFloat);
  public
  end;

var
  frmMain : TfrmMain;
  HHeight, HWidth, HThick : GLFloat;


implementation


{$R *.DFM}


procedure SetupPixelFormat ( DC : HDC
                           );
const
   PFD : TPIXELFORMATDESCRIPTOR = (
         nSize : SizeOf (TPIXELFORMATDESCRIPTOR); nVersion : 1;
         dwFlags : PFD_SUPPORT_OPENGL or PFD_DRAW_TO_WINDOW or PFD_DOUBLEBUFFER;
         iPixelType : PFD_TYPE_RGBA;
         cColorBits : 24; cRedBits : 0; cRedShift : 0; cGreenBits : 0; cGreenShift : 0;
         cBlueBits : 0; cBlueShift : 0; cAlphaBits : 0; cAlphaShift : 0; cAccumBits : 0;
         cAccumRedBits : 0; cAccumGreenBits : 0; cAccumBlueBits : 0; cAccumAlphaBits : 0;
         cDepthBits : 16; cStencilBits : 0; cAuxBuffers : 0; iLayerType : PFD_MAIN_PLANE;
         bReserved : 0; dwLayerMask : 0; dwVisibleMask : 0; dwDamageMask : 0);
var
  PixelFormat : Integer;
begin
   PixelFormat := ChoosePixelFormat (DC,@PFD);
   if (PixelFormat = 0) then
   begin
     Exit;
   end;

   if (SetPixelFormat (DC,PixelFormat,@PFD) <> True) then
   begin
     Exit;
   end;
end;


procedure TfrmMain.FormCreate ( Sender : TObject
                              );
var
  DC : HDC;
  RC : HGLRC;
begin
  DC := GetDC (pOGL.Handle);
  SetupPixelFormat (DC);
  RC := wglCreateContext (DC);
  wglMakeCurrent (DC,RC);

  { Quick and dirty lighting... }
  glEnable (GL_LIGHT0);
	glEnable (GL_LIGHTING);
  glEnable (GL_COLOR_MATERIAL);

  glClearColor (0.905,0.470,0.003,1);
  glCullFace (GL_BACK);

  glDepthFunc (GL_LEQUAL);
  glEnable (GL_DEPTH_TEST);

  glMatrixMode (GL_PROJECTION);
  glLoadIdentity;
  gluPerspective (45,frmMain.Width / frmMain.Height,1,100);
  glMatrixMode (GL_MODELVIEW);

  HHeight := 1;
  HWidth := 0.50;
  HThick := 0.13;
end;


procedure TfrmMain.Draw;
begin
  if (glIsEnabled (GL_POLYGON_SMOOTH)) then
  begin
    glClear (GL_COLOR_BUFFER_BIT);
  end else
  begin
    glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  end;

  { Draw two intersecting Hs... }
  glLoadIdentity;
  glTranslatef (0,0,-3);
  glRotatef (30,0,1,0);
  glRotatef (40,1,0,0);
  DrawH (HWidth,HHeight,HThick,0,1,0);

  glLoadIdentity;
  glTranslatef (0,0,-3);
  glRotatef (-20,1,0,0);
  glRotatef (60,0,0,1);
  DrawH (HWidth,HHeight,HThick,1,0,0);

  SwapBuffers (wglGetCurrentDC);
end;


procedure TfrmMain.FormKeyDown ( Sender : TObject;
                                 var Key : Word;
                                 Shift : TShiftState
                               );
begin
  if (Key = VK_SPACE) then
  begin
    if (glIsEnabled (GL_POLYGON_SMOOTH)) then
    begin
      glDisable (GL_BLEND);
      glDisable (GL_POLYGON_SMOOTH);
      glEnable (GL_DEPTH_TEST);
    end else
    begin
      glEnable (GL_BLEND);
      glEnable (GL_POLYGON_SMOOTH);
      glDisable (GL_DEPTH_TEST);
    end;
  end;
end;


procedure TfrmMain.Timer1Timer ( Sender : TObject
                               );
begin
  Draw;
end;


procedure TfrmMain.DrawH ( Width, Height, Thick, ColourR, ColourG, ColourB : GLFloat
                         );
begin
  glColor3f (ColourR,ColourG,ColourB);
  glBegin (GL_QUADS);
    { 4 cross bars. }
    { Front... }
    glNormal3f (0,0,1);
    glVertex3f (-Width,Thick,Thick);
    glVertex3f (-Width,-Thick,Thick);
    glVertex3f (Width,-Thick,Thick);
    glVertex3f (Width,Thick,Thick);

    { Back... }
    glNormal3f (0,0,-1);
    glVertex3f (-Width,Thick,-Thick);
    glVertex3f (-Width,-Thick,-Thick);
    glVertex3f (Width,-Thick,-Thick);
    glVertex3f (Width,Thick,-Thick);

    { Top... }
    glNormal3f (0,1,0);
    glVertex3f (-Width,Thick,Thick);
    glVertex3f (-Width,Thick,-Thick);
    glVertex3f (Width,Thick,-Thick);
    glVertex3f (Width,Thick,Thick);

    { Bottom... }
    glNormal3f (0,-1,0);
    glVertex3f (-Width,-Thick,Thick);
    glVertex3f (-Width,-Thick,-Thick);
    glVertex3f (Width,-Thick,-Thick);
    glVertex3f (Width,-Thick,Thick);

    { 4 left stand-ups. }
    { Inner... }
    glNormal3f (1,0,0);
    glVertex3f (-Width,-Height,Thick);
    glVertex3f (-Width,-Height,-Thick);
    glVertex3f (-Width,Height,-Thick);
    glVertex3f (-Width,Height,Thick);

    { Outer... }
    glNormal3f (-1,0,0);
    glVertex3f (-(Width + (Thick * 2)),-Height,Thick);
    glVertex3f (-(Width + (Thick * 2)),-Height,-Thick);
    glVertex3f (-(Width + (Thick * 2)),Height,-Thick);
    glVertex3f (-(Width + (Thick * 2)),Height,Thick);

    { Back... }
    glNormal3f (0,0,-1);
    glVertex3f (-(Width + (Thick * 2)),-Height,-Thick);
    glVertex3f (-(Width + (Thick * 2)),Height,-Thick);
    glVertex3f (-Width,Height,-Thick);
    glVertex3f (-Width,-Height,-Thick);

    { Front... }
    glNormal3f (0,0,1);
    glVertex3f (-(Width + (Thick * 2)),-Height,Thick);
    glVertex3f (-(Width + (Thick * 2)),Height,Thick);
    glVertex3f (-Width,Height,Thick);
    glVertex3f (-Width,-Height,Thick);

    { 4 right stand-ups. }
    { Inner... }
    glNormal3f (-1,0,0);
    glVertex3f (Width,-Height,Thick);
    glVertex3f (Width,-Height,-Thick);
    glVertex3f (Width,Height,-Thick);
    glVertex3f (Width,Height,Thick);

    { Outer... }
    glNormal3f (1,0,0);
    glVertex3f (Width + (Thick * 2),-Height,Thick);
    glVertex3f (Width + (Thick * 2),-Height,-Thick);
    glVertex3f (Width + (Thick * 2),Height,-Thick);
    glVertex3f (Width + (Thick * 2),Height,Thick);

    { Back... }
    glNormal3f (0,0,-1);
    glVertex3f (Width + (Thick * 2),-Height,-Thick);
    glVertex3f (Width + (Thick * 2),Height,-Thick);
    glVertex3f (Width,Height,-Thick);
    glVertex3f (Width,-Height,-Thick);

    { Front... }
    glNormal3f (0,0,1);
    glVertex3f (Width + (Thick * 2),-Height,Thick);
    glVertex3f (Width + (Thick * 2),Height,Thick);
    glVertex3f (Width,Height,Thick);
    glVertex3f (Width,-Height,Thick);

    { 4 ends... }
    { Left-bottom... }
    glNormal3f (0,-1,0);
    glVertex3f (-(Width + (Thick * 2)),-Height,Thick);
    glVertex3f (-(Width + (Thick * 2)),-Height,-Thick);
    glVertex3f (-Width,-Height,-Thick);
    glVertex3f (-Width,-Height,Thick);

    { Left-top... }
    glNormal3f (0,1,0);
    glVertex3f (-(Width + (Thick * 2)),Height,Thick);
    glVertex3f (-(Width + (Thick * 2)),Height,-Thick);
    glVertex3f (-Width,Height,-Thick);
    glVertex3f (-Width,Height,Thick);

    { Right-bottom... }
    glNormal3f (0,-1,0);
    glVertex3f (Width + (Thick * 2),-Height,Thick);
    glVertex3f (Width + (Thick * 2),-Height,-Thick);
    glVertex3f (Width,-Height,-Thick);
    glVertex3f (Width,-Height,Thick);

    { Right-top... }
    glNormal3f (0,1,0);
    glVertex3f (Width + (Thick * 2),Height,Thick);
    glVertex3f (Width + (Thick * 2),Height,-Thick);
    glVertex3f (Width,Height,-Thick);
    glVertex3f (Width,Height,Thick);
  glEnd;
end;


end.
